import java.io.*;
import java.util.*;

public class TestGen {

    public static void main(String[] args) throws Exception {
        new File("../preliminary").mkdir();
        new File("../tests").mkdir();
        new File("../common").mkdir();
        desc = new PrintWriter("../tests.desc");

        done = 0;
        genSample();
        //genValidatorCheck1();
        //genValidatorCheck2();

        //-------------------------first group-------------------------------------------------
        subtask = "subtask1";

        genRand(3, 7, 50);
        genExpensive(100, 1, 100);
        genMaxMoney(5, 5, 20);
        genSoMuchMoney(1, 10, 50);
        genNoMoney(5, 5, 20);
        genMuchMoney(5, 5, 20);

        for (int i = 0; i < 4; i++) {
            int n = rand(MAXN1) + 1;
            int m = rand(MAXN1) + 1;
            genRand(n, m, MAXT);

            n = rand(MAXN1) + 1;
            m = rand(MAXN1) + 1;
            genExpensive(n, m, MAXT);

            n = rand(MAXN1) + 1;
            m = rand(MAXN1) + 1;
            genMaxMoney(n, m, MAXT);

            n = rand(MAXN1) + 1;
            m = rand(MAXN1) + 1;
            genSoMuchMoney(n, m, MAXT);

            n = rand(MAXN1) + 1;
            m = rand(MAXN1) + 1;
            genNoMoney(n, m, MAXT);

            n = rand(MAXN1) + 1;
            m = rand(MAXN1) + 1;
            genMuchMoney(n, m, MAXT);

        }

        genRand(MAXN1, MAXN1, MAXT);
        genExpensive(MAXN1, MAXN1, MAXT);
        genMaxMoney(MAXN1, MAXN1, MAXT);
        genSoMuchMoney(MAXN1, MAXN1, MAXT);
        genNoMoney(MAXN1, MAXN1, MAXT);
        genMuchMoney(MAXN1, MAXN1, MAXT);


        desc.println(String.format("comment_subtask%d=\"n, m &lt;= %d\"", 1, MAXN1));
        desc.println(String.format("bonus_subtask%d=%d", 1, 50));

        //------------------------second group------------------------------------------------
        subtask = "subtask2";


        for (int i = 0; i < 4; i++) {
            int n = rand(MAXN2) + 1;
            int m = rand(MAXN2) + 1;
            genRand(n, m, MAXT);

            n = rand(MAXN2) + 1;
            m = rand(MAXN2) + 1;
            genExpensive(n, m, MAXT);

            n = rand(MAXN2) + 1;
            m = rand(MAXN2) + 1;
            genMaxMoney(n, m, MAXT);

            n = rand(MAXN2) + 1;
            m = rand(MAXN2) + 1;
            genSoMuchMoney(n, m, MAXT);

            n = rand(MAXN2) + 1;
            m = rand(MAXN2) + 1;
            genNoMoney(n, m, MAXT);

            n = rand(MAXN2) + 1;
            m = rand(MAXN2) + 1;
            genMuchMoney(n, m, MAXT);

        }

        genRand(MAXN2, MAXN2, MAXT);
        genExpensive(MAXN2, MAXN2, MAXT);
        genMaxMoney(MAXN2, MAXN2, MAXT);
        genSoMuchMoney(MAXN2, MAXN2, MAXT);
        genNoMoney(MAXN2, MAXN2, MAXT);
        genMuchMoney(MAXN2, MAXN2, MAXT);


        desc.println(String.format("comment_subtask%d=\"n, m &lt;= %d\"", 2, MAXN2));
        desc.println(String.format("bonus_subtask%d=%d", 2, 50));


        desc.close();
    }

    static int done = 0;
    static PrintWriter desc;
    static final Random rnd = new Random(3289214075201L);
    static final int MAXN1 = 1000;
    static final int MAXN2 = 100_000;
    static final int MAXT = 1_000_000_000;
    static final int MAXC = 1000;

    static int rand(int n) {
        if (n < 1)
            return 0;
        return rnd.nextInt(n);
    }

    static int nand(int n) {
        return rand(n / 2) + n / 2;
    }

    static boolean trueOrFalse() {
        return rnd.nextBoolean();
    }

    static class Pair {
        int x, y;

        Pair() {
            this.x = 0;
            this.y = 0;
        }

        Pair(int x, int y){
            this.x = x;
            this.y = y;
        }

    }

    static void print(int c1, int c2, Pair[] a, Pair[] b) throws IOException {
        done++;
        System.err.println("Generation test #" + done);
        PrintWriter out;
        if (done < 10)
            out = new PrintWriter("../tests/0" + String.valueOf(done));
        else
            out = new PrintWriter("../tests/" + String.valueOf(done));
        out.println(String.format("%d %d", c1, c2));
        out.println(String.format("%d", a.length));
        for (int i = 0; i < a.length; i++) {
            out.println(String.format("%d %d", a[i].x, a[i].y));
        }
        out.println(String.format("%d", b.length));
        for (int i = 0; i < b.length; i++) {
            out.println(String.format("%d %d", b[i].x, b[i].y));
        }
        out.close();

        //-----common

        if (done + 1 < 10)
            out = new PrintWriter("../common/0" + String.valueOf(done + 1));
        else
            out = new PrintWriter("../common/" + String.valueOf(done + 1));
        out.println(String.format("%d %d", c1, c2));
        out.println(String.format("%d", a.length));
        for (int i = 0; i < a.length; i++) {
            out.println(String.format("%d %d", a[i].x, a[i].y));
        }
        out.println(String.format("%d", b.length));
        for (int i = 0; i < b.length; i++) {
            out.println(String.format("%d %d", b[i].x, b[i].y));
        }
        out.close();
    }

    static String getPath() {
        if (done < 10)
            return "../tests/0" + String.valueOf(done);
        return "../tests/" + String.valueOf(done);
    }

    static void print_desc(String path, String folder, String subtask, int points, String comment) throws IOException {
        desc.println(String.format("%s, folder=%s, subtask=%s, points=%d, comment=\"%s\"", path, folder, subtask, points, comment));
    }

    static String subtask;

    static void print_desc_t(String comment) throws IOException {
        print_desc(getPath(), "tests", subtask, 0, comment);
    }

    //begin generators

    static void genSample() throws IOException {
        PrintWriter out;
        String path;
        path = "../preliminary/01";
        out = new PrintWriter(path);
        out.println("100 200");
        out.println("3");
        out.println("100 1");
        out.println("200 10");
        out.println("400 21");
        out.println("4");
        out.println("12 22");
        out.println("2 4");
        out.println("5 23");
        out.println("8 19");
        out.close();
        print_desc(path, "preliminary", "subtask0", 0, "sample 1");
        path = "../common/01";
        out = new PrintWriter(path);
        out.println("100 200");
        out.println("3");
        out.println("100 1");
        out.println("200 10");
        out.println("400 21");
        out.println("4");
        out.println("12 22");
        out.println("2 4");
        out.println("5 23");
        out.println("8 19");
        out.close();
    }

    static Pair[] genTimes(int m, int max) throws Exception {
        int n = 2 * m;
        if (max < n) {
            throw new IllegalArgumentException("max < n");
        }
        HashSet<Integer> was = new HashSet<>();
        for (int i = 0; i < n; i++) {
            int tmp = rand(max) + 1;
            while (was.contains(tmp)) {
                tmp++;
            }
            was.add(tmp);
        }
        int[] times = new int[n];
        int k = 0;
        for (Integer i: was) {
            times[k++] = i;
        }
        Arrays.sort(times);
        boolean[] used = new boolean[n];
        for (int i = 0; i < n; i++) {
            used[i] = false;
        }
        Pair[] res = new Pair[m];
        k = 0;
        for (int i = 0; i < m; i++) {
            res[i] = new Pair();
            while (used[k]) {
                k++;
            }
            res[i].x = times[k];
            used[k] = true;
            int tmp = rand(n - k) + k + 1;
            int tmp_ = tmp;
            while (tmp < n && used[tmp]) {
                tmp++;
            }
            if (tmp == n) {
                tmp_--;
                while (tmp_ > k && used[tmp_]) {
                    tmp_--;
                }
                if (tmp == k) {
                    throw new Exception("WTF???");
                }
                tmp = tmp_;
            }
            used[tmp] = true;
            res[i].y = times[tmp];
        }
        shuffle(res);
        return res;
    }

    static void shuffle(Pair[] a) {
        for (int i = 0; i < a.length; i++) {
            int j = rnd.nextInt(a.length);
            Pair tmp = a[j];
            a[j] = a[i];
            a[i] = tmp;
        }
    }

    static void genRand(int n, int m, int maxt) throws Exception {
        int C1 = rand(MAXC) + 1;
        int C2 = rand(MAXC - C1) + C1 + 1;
        Pair[] a = new Pair[n];
        for (int i = 0; i < n; i++) {
            a[i] = new Pair();
            a[i].x = rand(MAXC) + 1;
            a[i].y = rand(maxt) + 1;
        }
        Pair[] b = genTimes(m, maxt);
        print(C1, C2, a, b);
        print_desc_t(String.format("Random test, n = %d, m = %d, Maximal time is %d", n, m, maxt));
    }

    private static void genValidatorCheck1() throws IOException {
        int c1 = 1;
        int c2 = 1;
        Pair[] a = new Pair[1];
        a[0] = new Pair(1, 1);
        Pair[] b = new Pair[1];
        b[0] = new Pair(1, 1);
        print(c1, c2, a, b);
    }

    private static void genValidatorCheck2() throws IOException {
        int c1 = 1;
        int c2 = 1;
        Pair[] a = new Pair[1];
        a[0] = new Pair(1, 1);
        Pair[] b = new Pair[2];
        b[0] = new Pair(1, 2);
        b[1] = new Pair(2, 4);
        print(c1, c2, a, b);
    }

    static void genNoMoney(int n, int m, int maxt) throws Exception {
        int C1 = rand(MAXC) + 1;
        int C2 = rand(MAXC - C1) + C1 + 1;
        Pair[] a = new Pair[n];
        int maxt_ = rand(maxt / 2) + maxt / 2 + 1;
        while (maxt_ < 2 * m) {
            maxt_ = rand(maxt / 2) + maxt / 2 + 1;
        }
        for (int i = 0; i < n; i++) {
            a[i] = new Pair();
            a[i].x = rand(MAXC) + 1;
            a[i].y = rand(maxt - maxt_) + 1 + maxt_;
        }
        Pair[] b = genTimes(m, maxt_);
        print(C1, C2, a, b);
        print_desc_t(String.format("All money are after things, n = %d, m = %d, Maximal time is %d", n, m, maxt));
    }

    static void genMuchMoney(int n, int m, int maxt) throws Exception {
        int C1 = rand(MAXC) + 1;
        int C2 = rand(MAXC - C1) + C1 + 1;
        Pair[] a = new Pair[n];
        int maxt_ = rand(maxt / 2);
        while (maxt - maxt_ < 2 * m) {
            maxt_ = rand(maxt / 2);
        }
        for (int i = 0; i < n; i++) {
            a[i] = new Pair();
            a[i].x = rand(MAXC) + 1;
            a[i].y = rand(maxt_) + 1;
        }
        Pair[] b = genTimes(m, maxt - maxt_);
        for (int i = 0; i < b.length; i++) {
            b[i].x += maxt_;
            b[i].y += maxt_;
        }
        print(C1, C2, a, b);
        print_desc_t(String.format("All money are before things, n = %d, m = %d, Maximal time is %d", n, m, maxt));
    }

    static void genExpensive(int n, int m, int maxt) throws Exception {
        int C1 = MAXC;
        int C2 = MAXC;
        Pair[] a = new Pair[n];
        for (int i = 0; i < n; i++) {
            a[i] = new Pair();
            a[i].x = 1;
            a[i].y = rand(maxt) + 1;
        }
        Pair[] b = genTimes(m, maxt);
        print(C1, C2, a, b);
        print_desc_t(String.format("C1 and C2 are big, a_i are very small, n = %d, m = %d, Maximal time is %d", n, m, maxt));
    }

    static void genSoMuchMoney(int n, int m, int maxt) throws Exception {
        int C1 = 1;
        int C2 = 2;
        Pair[] a = new Pair[n];
        for (int i = 0; i < n; i++) {
            a[i] = new Pair();
            a[i].x = MAXC;
            a[i].y = rand(maxt) + 1;
        }
        Pair[] b = genTimes(m, maxt);
        print(C1, C2, a, b);
        print_desc_t(String.format("maximal a_i and small prices, n = %d, m = %d, Maximal time is %d", n, m, maxt));
    }

    static void genMaxMoney(int n, int m, int maxt) throws Exception {
        int C1 = MAXC;
        int C2 = MAXC;
        Pair[] a = new Pair[n];
        for (int i = 0; i < n; i++) {
            a[i] = new Pair();
            a[i].x = MAXC;
            a[i].y = rand(maxt) + 1;
        }
        Pair[] b = genTimes(m, maxt);
        print(C1, C2, a, b);
        print_desc_t(String.format("maximal a_i and prices, n = %d, m = %d, Maximal time is %d", n, m, maxt));
    }



    //end generator

}
