#include <bits/stdc++.h>
#define NAME "lottery"
using namespace std;
const int MOD = 1000000000 + 7;
typedef long long ll;


struct query {
	int l, r, x;
	query(int _l, int _r, int _x) : l(_l), r(_r), x(_x){}
	query(){}
};

struct segment_tree {
	segment_tree(int n) {
		t = new vertex[4 * n];
		build(1, 0, n);
	}
	segment_tree() {
		t = new vertex[0];
	}

	~segment_tree() {
		delete[] t;
	}

	int get(int l, int r) {
		return get(1, l, r);
	}

	void upd(int l, int r) {
		upd(1, l, r);
	}
private:
	struct vertex {
		int l, r, val, c;
		vertex() {l=r=val=0;}
		vertex(int _l, int _r, int _val, int _c) : l(_l), r(_r), val(_val), c(_c) {}
	};

	vertex* t;
	void build(int v, int l, int r) {
		t[v] = vertex(l, r, 1, 0);
		if (r - l == 1)
			return;
		int m = (r + l) / 2;
		build(2 * v, l, m);
		build(2 * v + 1, m, r);
		t[v].val = t[2*v].val + t[2*v+1].val;
	}

	void push(int v) {
		if (!t[v].c)
			return;
		t[2*v].c = t[2*v+1].c = t[v].c;
		t[v].c = 0;
		t[2*v].val = t[2*v+1].val = 0;
	}

	int get(int v, int l, int r) {
		if (t[v].l >= r || t[v].r <= l)
			return 0;
		if (t[v].l >= l && t[v].r <= r) 
			return t[v].val;
		push(v);
		return get(2 * v, l, r) + get(2 * v + 1, l, r);
	}

	void upd(int v, int l, int r) {
		if (t[v].l >= r || t[v].r <= l)
			return;
		if (t[v].l >= l && t[v].r <= r) {
			t[v].c = 1;
			t[v].val = 0;
			return;
		}
		push(v);
		upd(2 * v, l, r);
		upd(2 * v + 1, l, r);
		t[v].val = t[2*v].val + t[2*v+1].val;
	}
};

bool cmp(query a, query b) {
	return a.x < b.x || (a.x == b.x && a.l < b.l);
}         


ll pow(int a, int x) {
	if (x == 0)
		return 1;
	if ((x & 1) == 0) {
		ll t = pow(a, x/2); 
		return (t * t) % MOD;
	}
	return (pow(a, x - 1) * a) % MOD;
}

int f(int x, int len) {
	return (pow(x, len) - pow(x-1, len) + MOD) % MOD;
}

struct event {
	int nmb;
	int cnt;
	int op;
	int pos;
	event(int _nmb, int _pos) : nmb(_nmb), pos(_pos) {}
};

bool cmp1(event a, event b) {
	return a.pos < b.pos || (a.pos == b.pos && a.nmb > b.nmb);
}

ll dp[2101][2101];
int bl[100000];
segment_tree st(100001);


int main() {
	freopen(NAME".in", "r", stdin);
	freopen(NAME".out", "w", stdout);

	int n, m, k;
	scanf("%d%d%d", &n, &m, &k);
	vector<query> q;
	for (int i = 0; i < m; ++i) {
		int l, r, x;
		scanf("%d%d%d", &l, &r, &x);
		q.push_back(query(--l, --r, x));
	}
	sort(q.begin(), q.end(), cmp);
	ll ans = 1;	
	for (int i = 0; i < q.size(); ++i) {
		int cnt = st.get(q[i].l, q[i].r + 1);
		ans *= f(q[i].x, cnt);
		ans %= MOD;
		
		st.upd(q[i].l, q[i].r + 1);					
	}
	int cnt = st.get(0, n);
	if (cnt > 0) {
		ans *= pow(k, cnt);
		ans %= MOD;
	}	
	printf("%d", (int)ans);
	return 0;
}
